# Viko.ai

## INTRODUCTION

This module provides a [Viko.ai](https://www.viko.co.uk/) backend for the
[Search API](https://www.drupal.org/project/search_api) module.

Viko.ai service is a compelling alternative to chatbots, which handles
unexpected questions with ease. Live answers to any question are backed by your
existing information sources.

The module functionality is based on 2 main parts:

1. Your site content indexed to the Viko.ai Search API backend.
2. Blocks provide the best answers to user questions.

See the "Configuration" section for setup steps.

## REQUIREMENTS

1. Viko.ai API credentials (pair of "tenancy" and "key" values). Contact
   [Viko.ai](https://www.viko.co.uk/pricing/) to get your account created.
2. [Search API](https://www.drupal.org/project/search_api) module. No special
   knowledge of the module is required for basic operation, but it's recommended
   to check the [module's documentation](https://www.drupal.org/node/2852816)
   for a better understanding of provided functionality.

## INSTALLATION

The module can be installed via the
[standard Drupal installation process](https://drupal.org/node/1897420).

## CONFIGURATION

At least the "Search API backend" and one of the following blocks should be
created for a complete setup.

### Search API backend

1. Go to "/admin/config/search/search-api" and click "Add server".
2. Fill in a name (e.g. "Viko.ai server") and select "Viko.ai" as "Backend".
3. Fill in your "API tenancy" and "API key", and click "Save".
4. Go to "/admin/config/search/search-api" again and click "Add index".
5. Fill in a name (e.g. "Viko.ai index") and select "Content" as "Datasources".
6. Optionally, you can limit indexed content bundles or languages in the
   "Configure the Content datasource" fieldset.
7. Select your server created in step #2 as "Server", and click "Save".
8. Go to index "Fields" tab and click on "Add fields".
9. Click on "Add" next to the "Rendered HTML output" general field and
   select "Search index" (or other appropriate) view mode for all content types.
10. Click "Save", then "Done", and finally "Save changes".
11. Go to index "Processors" tab, enable "Entity status", and click "Save".
12. Go to index "View" tab, click on "Index now", and wait to complete.

### Question block

This block can be used to ask a question on your site frontend and receive a
live answer generated by the Viko.ai backend.

1. Go to "/admin/structure/block" or your other layout builder tool.
2. Click on "Place block" next to a region (e.g. "Content").
3. Search for "Viko.ai Question" block type and click "Place block" next to it.
4. Select your existing Search API backend as "Server".
5. Optionally, fill in a "Default folder" to be used for front page.
6. Optionally, define a visibility rules, as for any other block type.
7. Click "Save block" to complete.

### FAQ block

This block can be used to show frequently asked questions and answers.

1. Go to "/admin/structure/block" or your other layout builder tool.
2. Click on "Place block" next to a region (e.g. "Content").
3. Search for "Viko.ai FAQ" block type and click "Place block" next to it.
4. Select your existing Search API backend as "Server".
5. Optionally, fill in a "Default folder" to be used for front page.
6. Optionally, define a visibility rules, as for any other block type.
7. Click "Save block" to complete.

## Developers

See [Viko.ai REST API documentation](https://www.viko.co.uk/docs/api/) for
basic concepts, endpoints, and implementation guides.
